<?php
include('/usr/fallback/beroConf.php');
include('/usr/local/php/include/fulltrace.Class.php');
include_once('/usr/www/include/SQLite2ToSQLite3.php');
require_once('/usr/local/www/berogui/includes/Helper/HelperHtml.php');

/**
 * Implements the debug funtions of the gateway
 * @author Florian Kraatz <fk@beronet.com>
 * @author Miguel Palmer <mp@beronet.com>
 */
class FulltraceGui {

	private	$_ba,
					$_bc,
					$_ft;

	private $m_attr;

	private	$action = 'default';

	private $isRequestRejected = 0,
					$reasonRejected = array();

	/**
	* Constructor
	*/
	function __construct($m, $get = array(), $post = array(), $session = array()) {
		// load classes
		$this->_ba = new beroAri();
		$this->_bc = new beroConf('root');
		$this->_ft = new fulltrace();

		// set main GET variable
		$this->m_attr = $m;

		// get values from submit
		if (isset($get['error'])) {
			$this->isRequestRejected = 1;
			$this->reasonRejected = array('request' => $get['request'], 'checkor' => $get['checkor'], 'key' => $get['key']);
			unset($get['error'], $get['request'], $get['checkor'], $get['key']);
		}
		else if (isset($get['action'])) {
			$list_get = array('action' => 'select');
			$list_options = array(
				'action' => array('start', 'stop', 'default')
			);

			$is_safe = 1;
			$get = Helper::sanitizeGet($get, $list_get, $is_safe, $this->reasonRejected, $list_options);
			if ($is_safe) {
				$this->action = $get['action'];
			}
			else {
				$this->isRequestRejected = 1;
			}
			unset($get['action']);
		}
	}

	private function _show_trace_run() {
		ob_start();
		?>
		<br />
		<form method="POST" class="form-horizontal" action='modules/FulltraceGui/fulltracegui_submit.php'>
			<p class="text-center lead" ><?php echo FULL_TRACE_TABLE_HEADER_DIS ?></p>
			<div class='form-group text-center' id="ntphost">
				<img src="includes/images/punkt_gruen.gif" style="margin-right: 15px;">
				<input type="submit" class="btn btn-default" id="cancel_trace" name="trace" title="<?php echo DEBUG_CANCEL_TRACE; ?>" data-toggle="tooltip" value=<?php echo DEBUG_CANCEL_BUTTON_TEXT; ?> />
				<input type="submit" class="btn btn-default" id="stop_trace" name="trace" title="<?php echo DEBUG_STOP_TRACE; ?>" data-toggle="tooltip" value="Stop" />
			</div>
		</form><br />
		<?php
		$ret .= ob_get_clean();

		// we don't display file-download during trace if we're not 'advanced'
		if (((strlen($this->_ba->get('gui_mode')) == 0) ? 'easy' : $this->_ba->get('gui_mode')) != 'advanced') {
			return($ret);
		}

		// get data
		foreach ($this->_ft->get_runtime_files() as $ftFile) {
			if (empty($ftFile)) {
				continue;
			}
			$ftFiles[] = array('name' => basename($ftFile), 'size' => filesize($ftFile));
			$fileName[] = basename($ftFile);
			$fileSize[] = filesize($ftFile);
		}

		// sort by file-size
		array_multisort($fileSize, SORT_DESC, $fileName, $ftFiles);

		// output
		ob_start();
		?>
		<hr>
		<p class="text-center lead" ><?php echo FULL_TRACE_SINGLE_TABLE_HEADER_DIS ?></p>
		<?php foreach ($ftFiles as $ftFile): ?>
			<form name="download_logfile" action="modules/FulltraceGui/isdn_trace.php?option=single_logfile" method="POST" class="form-horizontal">
				<div class='form-group' id="lan_netmask">
					<label for='logfile_name' class='col-sm-5 control-label'><?php echo $ftFile['name']; ?></label>
					<div class='col-sm-1'>
						<?php echo round(($ftFile['size'] / 1024), 2); ?> kB
					</div>
					<div class='col-sm-3'>
						<input type="hidden" name="logfile_name" value="<?php echo $ftFile['name']; ?>" />
						<input type="submit" class="btn btn-default" value="Download" />
					</div>
				</div>
			</form>
		<?php endforeach; ?>
		<hr>
		<?php
		$ret .= ob_get_clean();

		return($ret);
	}

	function table() {
		require_once('/usr/local/www/berogui/includes/Helper/HelperPstn.php');	
		require_once('/usr/local/www/berogui/includes/Helper/HelperHtml.php');
		$button = '';
		if (HelperPstn::hasAnalog($this->_ba)) {
			// set up a modal button
			$button = HelperHtml::modalButton(array(
				'btn-add'					=> 'FULL_TRACE_BUTTON_START_DIS',
				'href-id'					=> 'id_ft_popup',
				'modal-id' 				=> 'modaltrace',
				'modal-id-title'	=> 'id_modaltrace_title',
				'modal-title'			=> 'FULL_TRACE_MODAL_TITLE_DIS',
				'url-add' 				=> 'modules/FulltraceGui/fulltracegui_popup.php',
			));
			ob_start();
			?>
			<script>
				$(document).ready(function() {
					$('#id_ft_popup').click(function() {
						$('#id_ft_popup').attr('href', 'modules/FulltraceGui/fulltracegui_popup.php?mode='+ $('#fulltrace_basic').is(':checked') +'&options='+ encodeURIComponent($('#ft_advanced_options').val()));
					});
				});	
			</script>
			<?php
			$button .= ob_get_clean();
		}
		else {
			// set up a normal button
			$button = HelperHtml::buttons('trace', 'FULL_TRACE_BUTTON_START_DIS', array(
				'image'	=> "<img src='./includes/images/punkt_rot.gif'>&nbsp;&nbsp;&nbsp;",
				'name'	=> 'trace',
				'title' => 'DEBUG_START_TRACE'
			));
			ob_start();
			?>
			<script language='javascript'>
				$('#fulltraceform').validate({
					rules: {
						ft_advanced_options: {
							checkManual: true
						}
					},
				});	
			</script>
			<?php
			$button .= ob_get_clean();
		}

		$colspan = 2;
		$advanced_options="<input type='text' class='form-control' id='ft_advanced_options' name='ft_advanced_options' style='max-width:520px; min-width:300px;'>";
		$mode ="<div align=left> <input type='radio' name='fulltrace_type' id='fulltrace_basic' onclick='$(\"#advanced_fulltrace_settings\").hide();'  value='0' checked> ". FULL_TRACE_TYPE_BASIC ." <br>";
		$mode .="<input type='radio'  name='fulltrace_type' id='fulltrace_advanced' onclick='$(\"#advanced_fulltrace_settings\").show();' value='1'> ". FULL_TRACE_TYPE_ADVANCED ." <br> </div>";
		$html_str =	"<br/>
				<table class='table table-striped table-bordered' id='table' style='max-width:520px; min-width:300px; margin:auto; text-align: center;'>
				<tr>
				$table_td
				<td>
				$mode
				<div id='advanced_fulltrace_settings' align=left title=\"". FULL_TRACE_TYPE_OPTPARAMETER_TT ."\" data-toggle='tooltip' style='display:none;'>
				<br/>
				". FULL_TRACE_TYPE_OPTPARAMETER ."<br>
				$advanced_options
				</div>
				</td>
				$td
				</tr>
				</table>";
		
		ob_start();
		?>
		<br/>
		<form method='POST' id='fulltraceform' class="form-inline" action='modules/FulltraceGui/fulltracegui_submit.php'>
			<div style="display:table; margin: 0 auto;">
			<p class="text-center lead" ><?php echo FULL_TRACE_TABLE_HEADER_DIS ?></p>
			<div class='form-group' style="vertical-align: top;">
			</div>

			<?php echo $tech; ?>
			<?php echo $html_str; ?>
			</div>
			<br>
			<?php echo $button; ?>
		</form><br/>
		<hr>
		<?php
		return ob_get_clean();
	}

	function display() {

		$name = 'FULL_TRACE_TITLE_DIS';
		include('./includes/header.php');
		require_once('./includes/isgwtelnet.php');
		
		if ($this->isRequestRejected) {
			$ret .= Helper::displayErrorMessage($this->reasonRejected['request'], $this->reasonRejected['checkor'], $this->reasonRejected['key']);
		}

		if ($this->_ba->get('trace') == 1) {
			$ret .= $this->_show_trace_run();
		}
		else {
			$ret .= $this->table();
		}
		$ret .= "\n";

		$content = '';
		foreach (require('/usr/local/www/berogui/modules/FulltraceGui/fulltracegui_parameters.php') as $key => $file) {
			if ($key == 'DebugFiles' && $this->_bc->get('root', 'trace-state') == 'STOPPING') {
				$is_exists = true;
				$restore = $file['btns']['dld'];
				$restore['id'] = 'restoreDownload';
				$file['btns']['dld'] = array(
					'disabled'=> true,
					'id'			=> 'restoreDownload',
					'onclick' => '',
					'title' 	=> 'FULL_TRACE_LOADING_BTN_TOOLTIP',
					'value' 	=> 'FULL_TRACE_LOADING_BTN_DIS',
				);
				$content .= HelperHtml::fieldButtonsInline($file['label'], $file['btns'], $file['options'], "\t\t\t")
									.	$this->_ajaxDownload($restore);
			}
			else if (file_exists($file['name'])) {
				$file['options']['image'] = date("d M Y H:i", filectime($file['name']));
				$content .= HelperHtml::fieldButtonsInline($file['label'], $file['btns'], $file['options'], "\t\t\t");
			}
		}
		if (strlen($content)) {
			$ret .= HelperHtml::form($content, array('title' => 'FULL_TRACE_DOWNLOADS_DIS'), "\t\t");
		}

		//Rückgabe: Der Inhalt von der HTML-Seite
		return $ret;
	}

	private function _ajaxDownload($restore) {
		$restore_btn = "\n";
		$destination = base64_encode("/app/berogui/index.php?m=FulltraceGui");
		foreach (array('onclick', 'title', 'value') as $key) {
			$restore_btn .= "\t\t\t\t\t\t\t\t$('#{$restore['id']}').attr('$key', \"". (defined($restore[$key]) ? constant($restore[$key]) : $restore[$key]) ."\");\n";
		}
		ob_start();
?>
		<script>
			var intervalId = setInterval(downloadDebugFiles, 1000);
			function downloadDebugFiles() {
				$.ajax({
					data: {
						action: 'download',
					},
					error: function(res) {
						if (res.status == 400) {
							$('#ajaxErrors').html('<?php echo AJAX_ERROS_BAD_REQUEST; ?>');
						}
						else if (res.status == 408) {
							window.location.href = './includes/login.php?reason=sess_expd&destination=<?php echo $destination; ?>';
						}
					},
					success: function(res) {
						var state = JSON.parse(res);
						if (typeof state.completed !== 'undefined') {
							if (state.completed == '1') {
								clearInterval(intervalId);
								window.location.href = 'modules/FulltraceGui/fulltracegui_download.php';
					<?php echo $restore_btn; ?>
								$('#<?php echo $restore['id']; ?>').removeAttr('disabled');
								return;
							}
						}
					},
					timeout: 1000,
					type: 'POST',
					url: 'modules/FulltraceGui/fulltracegui_ajax.php',
				});
			}
		</script>
<?php
		return ob_get_clean();
	}
}
?>
